=== debian/changelog ===
libtoxcore (0.2.2-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS on hurd-i386
  * Disable buggy autotest

 -- Yangfl <mmyangfl@gmail.com>  Thu, 31 May 2018 01:56:04 +0800

libtoxcore (0.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #739860)

 -- Yangfl <mmyangfl@gmail.com>  Thu, 01 Mar 2018 13:14:54 +0800
