=== debian/changelog ===
libtoxcore (0.2.9-1) unstable; urgency=medium

  * New upstream release
  * Add package toxcore-utils
  * Add autopkgtest
  * Bump Standards-Version to 4.3.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Tue, 29 Jan 2019 14:36:37 +0800

libtoxcore (0.2.8-1) unstable; urgency=medium

  * New upstream release
  * Remove symbols that are considered private by upstream
  * Bump Standards-Version to 4.2.1
  * Add dep libopus-dev, libvpx-dev for libtoxcore-dev

 -- Yangfl <mmyangfl@gmail.com>  Tue, 06 Nov 2018 22:00:16 +0800
