=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper (>= 11~),
+ debhelper (>= 12~),
  cmake,
  pkg-config,
+ libconfig-dev,
  libncurses5-dev,
  libopus-dev,
  libsodium-dev,
  libvpx-dev,
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
@@ -29,7 +30,12 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, libtoxcore2 (= ${binary:Version}), libsodium-dev
+Depends:
+ ${misc:Depends},
+ libtoxcore2 (= ${binary:Version}),
+ libsodium-dev,
+ libopus-dev,
+ libvpx-dev,
 Description: Distributed, secure messenger - development headers
  Tox provides an encrypted, distributed, and extensible peer-to-peer platform
  that can be used for various forms of communication. Tox is intended to be used
@@ -37,3 +43,16 @@
  a lot more than just instant messaging.
  .
  This package contains the development headers.
+
+Package: toxcore-utils
+Architecture: any
+Section: net
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Distributed, secure messenger - DHT bootstrap tools
+ Tox provides an encrypted, distributed, and extensible peer-to-peer platform
+ that can be used for various forms of communication. Tox is intended to be used
+ as a multimedia messenger, but many people have shown that Tox can be used for
+ a lot more than just instant messaging.
+ .
+ This package contains DHT bootstrap tools, including DHT_bootstrap and
+ tox-bootstrapd.
