## libtoxcore 0.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "9")
+set(PROJECT_VERSION_PATCH "10")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
