=== debian/changelog ===
libtoxcore (0.2.10-1build2) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:00:48 +0000

libtoxcore (0.2.10-1build1) eoan; urgency=medium

  * No-change rebuild against libvpx6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 08 Aug 2019 15:34:58 +0000

libtoxcore (0.2.10-1) unstable; urgency=medium

  * New upstream release
  * Fix autopkgtest

 -- Yangfl <mmyangfl@gmail.com>  Thu, 04 Jul 2019 16:39:19 +0800
