=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libtoxcore
 Priority: optional
-Maintainer: Yangfl <mmyangfl@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
  debhelper (>= 12~),
  cmake,
