=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	dh build --buildsystem=cmake
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DTEST_TIMEOUT_SECONDS=120
+	dh_auto_configure -- -DTEST_TIMEOUT_SECONDS=120 -DSTRICT_ABI=ON
 
 # iphy@#toktok: some of the tests use 100 ports
 # And tox limits the range of ports it tries to 33445-33545 (101 ports)
