=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%toxcore-$1.tar.gz%,pgpsigurlmangle=s%archive/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/c-toxcore-$1.tar.gz.asc%" \
   https://github.com/TokTok/c-toxcore/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
