=== debian/changelog ===
libtoxcore (0.2.12-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Bump debhelper compat to 13
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Wed, 06 May 2020 02:42:32 +0800
