=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libtoxcore
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
+Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper (>= 12~),
+ debhelper-compat (= 13),
  cmake,
  pkg-config,
  libconfig-dev,
@@ -11,7 +10,8 @@
  libopus-dev,
  libsodium-dev,
  libvpx-dev,
-Standards-Version: 4.3.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
