=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_LDFLAGS_MAINT_APPEND =
 
 
 %:
@@ -20,6 +20,6 @@
 
 # iphy@#toktok: some of the tests use 100 ports
 # And tox limits the range of ports it tries to 33445-33545 (101 ports)
-override_dh_auto_test:
+#override_dh_auto_test:
 #	dh_auto_test --no-parallel
 # buggy - fail nearly everytime
