## libtoxcore 0.2.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 cmake_policy(VERSION 2.8.12)
 project(toxcore)
 
-set(CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)
+list(APPEND CMAKE_MODULE_PATH ${toxcore_SOURCE_DIR}/cmake)
 
 ################################################################################
 #
@@ -30,7 +30,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "12")
+set(PROJECT_VERSION_PATCH "13")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
@@ -114,6 +114,13 @@
 
 option(BUILD_TOXAV "Whether to build the tox AV library" ON)
 option(MUST_BUILD_TOXAV "Fail the build if toxav cannot be built" OFF)
+
+if(MSVC)
+  option(MSVC_STATIC_SODIUM "Whether to link libsodium statically for MSVC" OFF)
+  if(MSVC_STATIC_SODIUM)
+    add_definitions(-DSODIUM_STATIC=1 -DSODIUM_EXPORT)
+  endif()
+endif()
 
 include(Dependencies)
 
@@ -356,12 +363,6 @@
 #
 unit_test(toxav ring_buffer)
 unit_test(toxav rtp)
+unit_test(toxcore DHT)
 unit_test(toxcore crypto_core)
 unit_test(toxcore mono_time)
-unit_test(toxcore ping_array)
-unit_test(toxcore util)
-
-################################################################################
-#
-# :: Automated regression tests: create a tox network and run integration tests
-#
