=== debian/changelog ===
libtoxcore (0.2.13-1) unstable; urgency=medium

  * New upstream release
    * Fix CVE-2021-44847 (Closes: #1001711)
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Tue, 21 Dec 2021 15:49:21 +0800
