=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libsodium-dev,
  libvpx-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
